/* Компонет шкалы с отображением частоты сети */

// цвет шкалы сигнализирует о "нормальности" частоты
const GOOD_COLOR = "#66D682";
const BAD_COLOR = "#DB7878";

const gaugeParams = {
        min: 0,
        max: 55,
        dialRadius: 40,
        dialStartAngle: 180,
        dialEndAngle: 0,
        value: 0,
        fractionDigits: 1,
        valueDialClass: "value",
        viewBox: "0 0 100 57",
        color: function(value) {
            if(value >= 49.6 && value < 50.5) {
                return GOOD_COLOR;
            } else {
                return BAD_COLOR;
            }
        },
        label: function(value) {
            return value.toFixed(2);
        }
    };

let FrequencyGauge = {
    template: '<div id="frequency-gauge" class="gauge-container"></div>',
    props: {frequency: Number},
    mounted() {
        // можно не объявлять в data, т.к. не нужна реактивность
        this.gauge = new Gauge(this.$el, gaugeParams);
    },
    watch: {
        frequency: function(value) {
            this.gauge.setValue(value);
        }
    },
};
