class ModbusError(Exception):
    """ Коды поддерживаемых ошибок Modbus """

    def __init__(self, code):
        if code == 1:
            _message = "Принятый код функции не может быть обработан на ведомом"
        elif code == 2:
            _message = "Адрес данных, указанный в запросе, не доступен данному ведомому"
        elif code == 3:
            _message = "Величина, содержащаяся в поле данных запроса, является недопустимой величиной для ведомого"
        elif code == 6:
            _message = "Ведомый занят обработкой команды. Запрос необходимо повторить позже, когда ведомый освободится"
        elif code == 15:
            _message = "Запрошенные данные пока не получены. Например: состояние запрошенной зоны " \
                       "пока не известно «С2000-ПП», так как он ещё не получил от прибора (режим " \
                       "«Орион-Master») или пульта «С2000М» (режим «Орион-Slave») состояние именно " \
                       "этой зоны. Запрос необходимо повторить позже"
        else:
            _message = "Неизвестная ошибка протокола Modbus"

        super(ModbusError, self).__init__(f'{self.__class__.__name__}({code}): {_message}')


class WriteError(ModbusError):
    def __init__(self):
        BaseException.__init__(self, "Неудачная попытка записи")
