import logging

from spread_core.errors.project_errors import CommandError
from spread_core.mqtt.spread.variable import Variable
from .subginery import Subginery, _SubgineriesFunit
from ..engineries import shade


class Shading(Subginery):
    pass


class _ShadingFunit(_SubgineriesFunit):
    entity_type = Shading
    target_class = shade.Shade

    def set(self):
        for e in self.entity.engineries:
            if isinstance(e, self.target_class):
                try:
                    self.target_command(e, Variable(self.set_value)).set()
                except CommandError as ex:
                    logging.warning(ex)


Shading.funit_class = _ShadingFunit


class Motion(_ShadingFunit):
    target_command = shade.Motion


class PositionLevel(_ShadingFunit):
    target_command = shade.PositionLevel


class Rotation(_ShadingFunit):
    target_command = shade.Rotation


class PositionAngle(_ShadingFunit):
    target_command = shade.PositionAngle


Shading.settable_units = [
    Motion,
    PositionLevel,
    Rotation,
    PositionAngle
]
