import re
import time
from spread_core.bam.validation.base import corr_req_par


class HeaderProjectValidator:
    def __init__(self, data):
        if not isinstance(data, dict):
            raise ValueError('Wrong data structure (dict needed)')

        if not corr_req_par('id', int, data) or data['id'] < 1:
            raise ValueError('Wrong project id')

        if not corr_req_par('cloudCode', str, data) \
                or not re.match(r'[0-9]{12}$', data['cloudCode']):
            raise ValueError('Wrong project cloudCode')

        if not corr_req_par('name', str, data):
            raise ValueError('Wrong project name')

        if not corr_req_par('title', str, data):
            raise ValueError('Wrong project title')

        if not corr_req_par('rootLocationID', int, data) or data['rootLocationID'] < 1:
            raise ValueError('Wrong project rootLocationID')

        if not corr_req_par('pin', str, data):
            raise ValueError('Wrong project pin')
