from .. import jocket

from ..base import Topic


class TROS3Topic(Topic):
    protocol = 'Tros3'
    topic_type = None

    def __init__(self, p_id, entity_addr='#'):
        self.p_id = int(p_id)
        self.entity_addr = entity_addr

    def __str__(self):
        return f'{self.protocol}/{self.topic_type}/{self.p_id}/{self.entity_addr}'

    @classmethod
    def decompose(cls, action, project_id, *entity_address):
        entity_address = jocket.address.EntityAddress.deserialize(*entity_address)

        if action == TopicCommandTros3.topic_type:
            return TopicCommandTros3(project_id, entity_address)
        elif action == TopicStateTros3.topic_type:
            return TopicStateTros3(project_id, entity_address)


class TopicCommandTros3(TROS3Topic):
    topic_type = 'Command'


class TopicStateTros3(TROS3Topic):
    topic_type = 'State'
