from unittest import TestCase

from spread_core.mqtt import TopicError, topic_of


class TestTopic(TestCase):
    def PARSE(self, string, **attributes):
        """ Parse string, compare string with result instance and checking attributes accordance """

        instance = topic_of(string)
        self.assertEqual(string, instance)

        for key, value in attributes.items():
            self.assertEqual(getattr(instance, key), value)

        return instance

    def parse_invalid_topic(self, topic, expected_message=None):
        with self.assertRaises(TopicError) as ex:
            self.PARSE(topic)

        if expected_message:
            self.assertEqual(ex.exception.args[0], expected_message)


class TestCommon(TestTopic):
    def test_invalid_protocol(self):
        self.parse_invalid_topic('qwe')
